import { Vector } from './vector.js';

export class Polygon {
  constructor() {
    this.vertices = [];
    this.dim = 0;
  }

  addVertex(point) {
    point = point instanceof Vector ? point : Vector.from(point);
    if (!this.dim) {
      this.dim = point.dim;
    } else if (this.dim !== point.dim) {
      throw new Error('All vertices of a polygon must have the same dimensionality');
    }
    this.vertices.push(point);
  }
}
